/*
 * API documentation
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0-20181108155220-20181108155343
 * Contact: api.move@axa-assistance.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.insurance.bn.starter.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModelProperty;
import org.threeten.bp.LocalDate;

import java.util.Objects;

/**
 * AdditionalCost
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2018-12-19T23:23:06.995+01:00")
public class AdditionalCost {
  @SerializedName("date")
  private LocalDate date = null;

  @SerializedName("form_of_payment")
  private String formOfPayment = null;

  @SerializedName("price")
  private Model115 price = null;

  @SerializedName("amount_claimed")
  private Model116 amountClaimed = null;

  @SerializedName("description")
  private String description = null;

  public AdditionalCost date(LocalDate date) {
    this.date = date;
    return this;
  }

   /**
   * Date on which the purchase was made. ISO 8601 format (YYYY-MM-DD).
   * @return date
  **/
  @ApiModelProperty(value = "Date on which the purchase was made. ISO 8601 format (YYYY-MM-DD).")
  public LocalDate getDate() {
    return date;
  }

  public void setDate(LocalDate date) {
    this.date = date;
  }

  public AdditionalCost formOfPayment(String formOfPayment) {
    this.formOfPayment = formOfPayment;
    return this;
  }

   /**
   * The purchased form of payment.
   * @return formOfPayment
  **/
  @ApiModelProperty(example = "Credit card", value = "The purchased form of payment.")
  public String getFormOfPayment() {
    return formOfPayment;
  }

  public void setFormOfPayment(String formOfPayment) {
    this.formOfPayment = formOfPayment;
  }

  public AdditionalCost price(Model115 price) {
    this.price = price;
    return this;
  }

   /**
   * Get price
   * @return price
  **/
  @ApiModelProperty(value = "")
  public Model115 getPrice() {
    return price;
  }

  public void setPrice(Model115 price) {
    this.price = price;
  }

  public AdditionalCost amountClaimed(Model116 amountClaimed) {
    this.amountClaimed = amountClaimed;
    return this;
  }

   /**
   * Get amountClaimed
   * @return amountClaimed
  **/
  @ApiModelProperty(value = "")
  public Model116 getAmountClaimed() {
    return amountClaimed;
  }

  public void setAmountClaimed(Model116 amountClaimed) {
    this.amountClaimed = amountClaimed;
  }

  public AdditionalCost description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Description of the additional cost (restaurant, hotel,...).
   * @return description
  **/
  @ApiModelProperty(value = "Description of the additional cost (restaurant, hotel,...).")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    AdditionalCost additionalCost = (AdditionalCost) o;
    return Objects.equals(this.date, additionalCost.date) &&
        Objects.equals(this.formOfPayment, additionalCost.formOfPayment) &&
        Objects.equals(this.price, additionalCost.price) &&
        Objects.equals(this.amountClaimed, additionalCost.amountClaimed) &&
        Objects.equals(this.description, additionalCost.description);
  }

  @Override
  public int hashCode() {
    return Objects.hash(date, formOfPayment, price, amountClaimed, description);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class AdditionalCost {\n");
    
    sb.append("    date: ").append(toIndentedString(date)).append("\n");
    sb.append("    formOfPayment: ").append(toIndentedString(formOfPayment)).append("\n");
    sb.append("    price: ").append(toIndentedString(price)).append("\n");
    sb.append("    amountClaimed: ").append(toIndentedString(amountClaimed)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

